﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Media3D;

namespace Panel3D
{
  public class ModelVisual3DFilter
  {
    public bool Triangles { get; set; }
    public bool Texts3D { get; set; }
    public bool Texts2D { get; set; }
    public bool Lines { get; set; }
    private ModelVisual3DFilter (bool EnableTriangles,
      bool EnableTexts3D,
      bool EnableTexts2D,
      bool EnableLines)
    {
      Triangles=EnableTriangles;
      Texts3D = EnableTexts3D;
      Texts2D = EnableTexts3D;
      Lines = EnableLines;
    }
    public static ModelVisual3DFilter AllOn
    {
      get
      {
        return new ModelVisual3DFilter(true, true, true, true);
      }
    }
    public static ModelVisual3DFilter AllOnExceptTexts
    {
      get
      {
        return new ModelVisual3DFilter(true, false, false, true);
      }
    }
    public static ModelVisual3DFilter AllOff
    {
      get
      {
        return new ModelVisual3DFilter(false, false, false, false);
      }
    }
  }
  public interface IModelVisual3D
  {
    ModelVisual3D GetModelVisual3D(ModelVisual3DFilter FilterSettings);
    UIElement GetUIElement(ModelVisual3DFilter FilterSettings, Viewport3D DestinationViewport3D);
    void UpdateViewToLookDirection(Vector3D LookDirection);
  }
}
